
#include <stdio.h>
#include <string.h>
#include <time.h>


FILE *fp, *fz, *fk;
unsigned char *src;
unsigned char *key;
unsigned int nLen;		// source length
unsigned int kLen;		// key length
unsigned int kAnd;		// key length (for & use, much faster than modulo)

unsigned char xor1;
unsigned int  xor2;
unsigned int  xor3;
unsigned char tabs[6][0x100];
unsigned int tabi[0x20];
unsigned int tabii[2][5];
unsigned char *tab_a, *tab_b;


#define _xor1_0(j, k) \
			m ^= tab_a[tab_b[m ^ key[(((i + m) ^ j) ^ xor1) & kAnd]] ^ n] & (0x80 >> k); \
			n ^= tab_b[tab_a[n ^ key[(((i + n) ^ j) ^ xor3) & kAnd]] ^ m] & (0x01 << k); \

#define _xor1(j) \
			_xor1_0((j) ^ (xor2 & 7), (j))

#define ixor(tab0, tab1) \
			xor1 ^= i >> (((tab0[i & n] >> 4) & 5) | (tab1[m] & 2)) \

#define rotate(j) \
			xor1 = (xor1 << j) | (xor1 >> (8 - j)) \

#define rev(n) (((n & 1) << 7) | ((n & 2) << 5) | ((n & 4) << 3) | ((n & 8) << 1) \
		| ((n >> 1) & 8) | ((n >> 3) & 4) | ((n >> 5) & 2) | ((n >> 7) & 1))

#define swr(n) ((n & 0x81) | ((n >> 3) & 2) | ((n & 2) << 1) | ((n >> 2) & 8) | ((n & 4) << 2) | ((n >> 1) & 0x20) | ((n & 8) << 3))

#define invert_bit(j) (1 << (j ^ ((xor1 ^ i) & 0x07)))

#define BS5(n, b4, b3, b2, b1, b0)	\
		(((((n) >> (b4)) & 1) <<  4) | \
		 ((((n) >> (b3)) & 1) <<  3) | \
		 ((((n) >> (b2)) & 1) <<  2) | \
		 ((((n) >> (b1)) & 1) <<  1) |  \
		 ((((n) >> (b0)) & 1)))


void long_xor1(unsigned short ofst, unsigned char *dst)
{
	int x, y, i;

	y = tabs[5 ^ ((key[ ofst       & kAnd] >> ( xor3 & 7)) & 1)][(xor1     )       ] & 0x0f;
	x = tabs[4 ^ ((key[(ofst >> 8) & kAnd] >> (~xor3 & 7)) & 1)][(xor2 >> y) & 0xff] & 0x1f;

	x |= 1; // odd gives better results

	for (i = 0, xor3 = x; i < y; i++, xor3*=x);

	dst[0] ^= tabs[4 | (xor2 & 1)  ][(xor3 >>  0) & 0xff];
	dst[1] ^= tabs[4 | (xor1 & 1)  ][(xor3 >> 16) & 0xff];
	dst[2] ^= tabs[4 | (y & 1)     ][(xor3 >>  8) & 0xff];
	dst[3] ^= tabs[4 | (xor3 >> 31)][(xor3 >> 24) & 0xff];
}


unsigned char byte_xor2(unsigned short ofst, unsigned char i, unsigned int c)
{
	unsigned char r;

	xor2 <<= 0x01;
	xor2 |= (key[xor2 % kLen] >> (xor1 & 7)) & 1;
	xor2 ^= c;
	xor2 ^= i << 0x04;
	xor2 ^= rev(ofst >> 0x04) << 0x18;
	xor2 ^= ofst & 0x00f;
	xor2 ^= xor3 & 0xffffff00;

	r = xor2 >> 0x18;

	if ( xor2 & tabi[ 0]) r  = (r & 0xfe) | (xor2 & 0x01);
	if ( xor2 & tabi[ 1]) r  = (r << 0x01) | (r >> 0x07);
	if ( xor2 & tabi[ 2]) r ^= (xor2 >> 0x08) & 0x09;
	if (~xor2 & tabi[ 3]) r  = (r & 0xbf) | ((xor2 >> (i & 0x10)) & 0x40);
	if ( xor2 & tabi[ 4]) r  = invert_bit(7);
	if ( xor2 & tabi[ 5]) r  = (r << 0x04) | (r >> 0x04);
	if ( xor2 & tabi[ 6]) r ^= (xor2 >> 0x08) & 0x60;
	if ( xor2 & tabi[ 7]) r  = (r & 0xfb) | (xor2 & 0x04);
	if ( xor2 & tabi[ 8]) r ^= invert_bit(4);
	if (~xor2 & tabi[ 9]) r  = rev(r);
	if ( xor2 & tabi[10]) r ^= invert_bit(2);
	if (~xor2 & tabi[11]) r ^= (xor2 >> 0x08) & 0x90;
	if ( xor2 & tabi[12]) r  = (r & 0xf7) | (xor2 & 0x08);
	if ( xor2 & tabi[13]) r  = swr(r);
	if ( xor2 & tabi[14]) r ^= (xor2 >> 0x08) & 0x06;
	if ( xor2 & tabi[15]) r ^= invert_bit(6);
	if ( xor2 & tabi[16]) r  = (r & 0xef) | ((xor2 >> (c & 0x10)) & 0x10);
	if ( xor2 & tabi[17]) r  = (r << 0x07) | (r >> 0x01);
	if ( xor2 & tabi[18]) r ^= xor2 & 0xc0;
	if (~xor2 & tabi[19]) r ^= invert_bit(1);
	if (~xor2 & tabi[20]) r  = (r & 0xdf) | ((xor2 >> (c & 0x10)) & 0x20);
	if ( xor2 & tabi[21]) r ^= invert_bit(3);
	if ( xor2 & tabi[22]) r ^= xor2 & 0x03;
	if ( xor2 & tabi[23]) r ^= xor2 & 0x30;
	if (~xor2 & tabi[24]) r ^= invert_bit(0);
	if ( xor2 & tabi[25]) r  = (r & 0xfc) | ((r & 0x01) << 0x01) | ((r & 0x02) >> 0x01);
	if ( xor2 & tabi[26]) r ^= invert_bit(5);
	if (~xor2 & tabi[27]) r  = (r & 0xf9) | ((r & 0x02) << 0x01) | ((r & 0x04) >> 0x01);
	if ( xor2 & tabi[28]) r  = (r & 0x7f) | ((xor2 >> (i & 0x10)) & 0x80);
	if ( xor2 & tabi[29]) r ^= ~rev(r);
	if ( xor2 & tabi[30]) r ^= xor2 & 0x0c;
	if ( xor2 & tabi[31]) r ^= (r & 0xfd) | (xor2 & 0x02);

	xor2 ^= r;

	return r;
}


void fill_tab(unsigned char *tab, unsigned short ofst)
{
	int i = 0, j, c = 0;

	memset (tab, xor2 & 0xff, 0x100);

	while (i < 0xff)
	{
		unsigned char d = byte_xor2(ofst, i, c);

		j = 0;
		while (tab[j] != d && j < 0x100) j++;

		if (j == 0x100) {
			tab[i] = d;
			i++;
		}

		c++;
	}
}

void fill_tab_ii(int *tabii)
{
	int j = 0, k = 3, r = 0, f = 0;

	tabii[4] = byte_xor2(xor2 >> 16, xor1, ~xor3) % 5;

	while (k >= 0)
	{
		j = byte_xor2(xor2 >> 16, xor1, xor3 ^ f) % 5;
		for (r = k+1; r < 5; r++) {
			if (tabii[r] != j) continue;
			r = 99; break;
		}

		if (r < 99) {
			tabii[k] = j;
			k--;
		}

		f++;
	}
}

void fill_tabs(unsigned short ofst)
{
	fill_tab_ii(tabii[0]);
	fill_tab_ii(tabii[1]);

	int *r = tabii[(~key[xor2 % kLen] >> 4) & 1];
	int *f = tabii[(~key[xor2 % kLen] >> 3) & 1];
	int i, k = tabs[key[xor1 % kLen] % 6][xor2 >> 24] & 0x1f;
	for (i = 0; i < 32; i++) {
		tabi[BS5(i, f[0], f[1], f[2], f[3], f[4]) ^ k] = 1 << BS5(i, r[4], r[3], r[2], r[1], r[0]);
	}

	fill_tab(tabs[0 ^ (key[ofst % kLen] & 3)], ofst);
	fill_tab(tabs[1 ^ (key[ofst % kLen] & 3)], ofst);
	fill_tab(tabs[2 ^ (key[ofst % kLen] & 3)], ofst);
	fill_tab(tabs[3 ^ (key[ofst % kLen] & 3)], ofst);

	fill_tab(tabs[4], ofst ^ (key[ofst % kLen] << 4));
	fill_tab(tabs[5], ofst ^ (key[ofst % kLen] << 8));
}

unsigned char byte_xor1(unsigned int i)
{
	unsigned char m, n;

	m = i >> 0x18;
	n = i >> 0x10;

	_xor1(0);
	_xor1(1);
	_xor1(2);
	_xor1(3);
	_xor1(4);
	_xor1(5);
	_xor1(6);
	_xor1(7);

	tab_a = tabs[((i ^ n) & 2)    ];
	tab_b = tabs[((i ^ m) & 2) | 1];

	rotate(m & 7);

	ixor(tab_a, tab_b);
	ixor(tab_b, tab_a);

	rotate(n & 7);

	xor1 ^= tab_a[xor1 ^ key[xor2 % kLen]];
	xor1 ^= tab_b[i % ((m ^ n) + 1)];

	return xor1;
}



void crypt(unsigned char *src, unsigned int nLen)
{
	unsigned int i = 0, j = 0;
	unsigned int block = 0;

	while (kAnd > kLen) kAnd >>= 1;

	for (i = j = 0; i < kLen; i++, j^=key[i]);

	tab_a = tabs[(j >> 4) & 2];
	tab_b = tabs[(j & 2)  | 1];

	xor1 = (~j << 4) | (j >> 4);
	xor2 = key[xor1 % kLen] ^ (key[~xor1 % kLen] << 4);

	long_xor1(xor2, src);

	fill_tabs(~0);

	printf ("\nEn/De-crypting");

	for (i = 0; i < nLen; i+= 0x10000)
	{
		fill_tabs(i >> 16);

		block = (nLen - i) < 0x10000 ? (nLen - i) : 0x10000;

		fread (src, 1, block, fp);

		for (j = 0; j < block; j++)
		{
			src[j] ^= byte_xor1(i + j);
			src[j] ^= byte_xor2(i >> 16, xor1, j);
			long_xor1(j, src + j);
		}

		fwrite (src, 1, block, fz);
		printf (".");
	}

	kLen = kAnd = xor1 = xor2 = xor3 = 0;
	memset (tabs, 0, 0x600);
	memset (key, 0, kLen);
	memset (tabi, 0, 0x80);
	memset (tabii, 0, 10 * 2 * 4);
	tab_a = tab_b = NULL;
}



int main(int argc, char **argv)
{
	int kfile = 0;
	char filein[256], fileout[256];
	char tkey[256];

	kAnd = ~0;

	if (argc < 2)
	{
		printf ("Please type the name of the file to be en/de-crypted\n");
		fgets(filein, 256, stdin);
		if (filein[strlen(filein)-1] == '\n') filein[strlen(filein)-1] = '\0';
		strcpy (fileout, filein);
	}
	else
	{
		strcpy (fileout, argv[1]);
	}

	fp = fopen(fileout, "rb");

	if (fp == NULL)
	{
		printf ("File not found\n");
		fgets (filein, 1, stdin);
		return 1;
	}

	fseek (fp, 0, SEEK_END);
	nLen = ftell (fp);
	rewind (fp);

	if (argc < 3)
	{
		printf ("\nPlease type the name of the key file or the password you wish to use.\n");
		fgets(tkey, 256, stdin);
		if (tkey[strlen(tkey)-1] == '\n') tkey[strlen(tkey)-1] = '\0';
	}
	else
	{
		strcpy (tkey, argv[2]);
	}

	fk = fopen(tkey, "rb");
	if (fk != NULL)
	{
		printf ("\nUsing key file...\n");
		fseek (fk, 0, SEEK_END);
		kLen = ftell (fk);
		rewind (fk);

		key = (unsigned char *)malloc ( kLen );

		fread (key, 1, kLen, fk);
		fclose (fk);

		kfile = 1;
	}
	else
	{
		key = tkey;
		kLen = strlen( tkey );
	}

	strcat (fileout, ".enc");

	fz = fopen(fileout, "wb");

	src = (unsigned char*)malloc( 0x10000 );

	time_t xx = time(NULL);

	crypt(src, nLen);

	printf ("\n\nFinished in %d bytes in %d seconds\n", nLen, time(NULL)-xx);

	fclose (fp);
	fclose (fz);

	memset (tkey, 0, 0x100);

	if (kfile) {
		free (key);
		kfile = 0;
	}	
	free (src);
	key = src = NULL;
}

